//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Main.h"
#include <stdlib.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "LogBase"
#pragma link "LogError"
#pragma resource "*.dfm"
TfrmMain *frmMain;
//---------------------------------------------------------------------------
__fastcall TfrmMain::TfrmMain(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::rgTypeErrorDialogClick(TObject *Sender)
{
  SMExceptionLog->ErrorDialog = TSMLErrorDialog(rgTypeErrorDialog->ItemIndex);

}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::cbSendMailClick(TObject *Sender)
{
  if (cbSendMail->Checked == true)
    SMExceptionLog->Options << laShowSendEMail;
  else
    SMExceptionLog->Options >> laShowSendEMail;

}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::cbGoWEBClick(TObject *Sender)
{
  if (cbGoWEB->Checked == true)
    SMExceptionLog->Options << laShowSupportLink;
  else
    SMExceptionLog->Options >> laShowSupportLink;
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::edGoWEBExit(TObject *Sender)
{
  SMExceptionLog->SendTo->WWW = edGoWEB->Text;
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::edEMailExit(TObject *Sender)
{
  SMExceptionLog->SendTo->EMail = edEMail->Text;
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::edSubjectExit(TObject *Sender)
{
  SMExceptionLog->SendTo->EMailSubject = edSubject->Text;
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::memoBodyExit(TObject *Sender)
{
  SMExceptionLog->SendTo->EMailBody = memoBody->Lines->Text;
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::cbAttachLogClick(TObject *Sender)
{
  SMExceptionLog->SendTo->AttachLog = cbAttachLog->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::cbAttachScreenshotExit(TObject *Sender)
{
  SMExceptionLog->SendTo->AttachScreenShot = cbAttachScreenshot->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::cbOpenBeforeSendExit(TObject *Sender)
{
  SMExceptionLog->SendTo->EMailOpenBeforeSend = cbOpenBeforeSend->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::cbAddDateClick(TObject *Sender)
{
  if (cbAddDate->Checked == true)
    SMExceptionLog->Formats << lfDate;
  else
    SMExceptionLog->Formats >> lfDate;
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::cbAddTimeExit(TObject *Sender)
{
  if (cbAddTime->Checked == true)
    SMExceptionLog->Formats << lfTime;
  else
    SMExceptionLog->Formats >> lfTime;
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::cbAddPhysAddrExit(TObject *Sender)
{
  if (cbAddPhysAddr->Checked == true)
    SMExceptionLog->Formats << lfPhysAddress;
  else
    SMExceptionLog->Formats >> lfPhysAddress;
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::cbAddMessageClick(TObject *Sender)
{
  if (cbAddMessage->Checked == true)
    SMExceptionLog->Formats << lfMessage;
  else
    SMExceptionLog->Formats >> lfMessage;
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::cbAddSeparatorClick(TObject *Sender)
{
  if (cbAddSeparator->Checked == true)
    SMExceptionLog->Formats << lfSeparator;
  else
    SMExceptionLog->Formats >> lfSeparator;
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::btnRaiseClick(TObject *Sender)
{
  int i;

  SMExceptionLog->FilterStandard.Clear();
  if (cbAbort->Checked == true)
    SMExceptionLog->FilterStandard << efAbort;
  if (cbOutOfMemory->Checked == true)
    SMExceptionLog->FilterStandard << efOutOfMemory;
  if (cbInOutError->Checked == true)
    SMExceptionLog->FilterStandard << efInOutError;
  if (cbIntError->Checked == true)
    SMExceptionLog->FilterStandard << efIntError;
  if (cbDivByZero->Checked == true)
    SMExceptionLog->FilterStandard << efDivByZero;
  if (cbRangeError->Checked == true)
    SMExceptionLog->FilterStandard << efRangeError;
  if (cbIntOverflow->Checked == true)
    SMExceptionLog->FilterStandard << efIntOverflow;
  if (cbMathError->Checked == true)
    SMExceptionLog->FilterStandard << efMathError;
  if (cbInvalidOp->Checked == true)
    SMExceptionLog->FilterStandard << efInvalidOp;
  if (cbZeroDivide->Checked == true)
    SMExceptionLog->FilterStandard << efZeroDivide;
  if (cbOverflow->Checked == true)
    SMExceptionLog->FilterStandard << efOverflow;
  if (cbUnderflow->Checked == true)
    SMExceptionLog->FilterStandard << efUnderflow;
  if (cbInvalidPointer->Checked == true)
    SMExceptionLog->FilterStandard << efInvalidPointer;
  if (cbInvalidCast->Checked == true)
    SMExceptionLog->FilterStandard << efInvalidCast;
  if (cbConvertError->Checked == true)
    SMExceptionLog->FilterStandard << efConvertError;
  if (cbAccessViolation->Checked == true)
    SMExceptionLog->FilterStandard << efAccessViolation;
  if (cbPrivilege->Checked == true)
    SMExceptionLog->FilterStandard << efPrivilege;
  if (cbStackOverflow->Checked == true)
    SMExceptionLog->FilterStandard << efStackOverflow;
  if (cbControlC->Checked == true)
    SMExceptionLog->FilterStandard << efControlC;
  if (cbVariantError->Checked == true)
    SMExceptionLog->FilterStandard << efVariantError;
  if (cbPropReadOnly->Checked == true)
    SMExceptionLog->FilterStandard << efPropReadOnly;
  if (cbPropWriteOnly->Checked == true)
    SMExceptionLog->FilterStandard << efPropWriteOnly;
  if (cbExternalException->Checked == true)
    SMExceptionLog->FilterStandard << efExternalException;
  if (cbAssertionFailed->Checked == true)
    SMExceptionLog->FilterStandard << efAssertionFailed;
  if (cbAbstractError->Checked == true)
    SMExceptionLog->FilterStandard << efAbstractError;
  if (cbIntfCastError->Checked == true)
    SMExceptionLog->FilterStandard << efIntfCastError;
  if (cbInvalidContainer->Checked == true)
    SMExceptionLog->FilterStandard << efInvalidContainer;
  if (cbInvalidInsert->Checked == true)
    SMExceptionLog->FilterStandard << efInvalidInsert;
  if (cbPackageError->Checked == true)
    SMExceptionLog->FilterStandard << efPackageError;
  if (cbWin32Error->Checked == true)
    SMExceptionLog->FilterStandard << efWin32Error;



  SMExceptionLog->FilterClasses.Clear();
  if (cbStreamError->Checked == true)
    SMExceptionLog->FilterClasses << efStreamError;
  if (cbFCreateError->Checked == true)
    SMExceptionLog->FilterClasses << efFCreateError;
  if (cbFOpenError->Checked == true)
    SMExceptionLog->FilterClasses << efFOpenError;
  if (cbFilerError->Checked == true)
    SMExceptionLog->FilterClasses << efFilerError;
  if (cbReadError->Checked == true)
    SMExceptionLog->FilterClasses << efReadError;
  if (cbWriteError->Checked == true)
    SMExceptionLog->FilterClasses << efWriteError;
  if (cbClassNotFound->Checked == true)
    SMExceptionLog->FilterClasses << efClassNotFound;
  if (cbMethodNotFound->Checked == true)
    SMExceptionLog->FilterClasses << efMethodNotFound;
  if (cbInvalidImage->Checked == true)
    SMExceptionLog->FilterClasses << efInvalidImage;
  if (cbResNotFound->Checked == true)
    SMExceptionLog->FilterClasses << efResNotFound;
  if (cbListError->Checked == true)
    SMExceptionLog->FilterClasses << efListError;
  if (cbBitsError->Checked == true)
    SMExceptionLog->FilterClasses << efBitsError;
  if (cbStringListError->Checked == true)
    SMExceptionLog->FilterClasses << efStringListError;
  if (cbComponentError->Checked == true)
    SMExceptionLog->FilterClasses << efComponentError;
  if (cbParserError->Checked == true)
    SMExceptionLog->FilterClasses << efParserError;
  if (cbOutOfResources->Checked == true)
    SMExceptionLog->FilterClasses << efOutOfResources;
  if (cbInvalidOperation->Checked == true)
    SMExceptionLog->FilterClasses << efInvalidOperation;
  if (cbThread->Checked == true)
    SMExceptionLog->FilterClasses << efThread;



  SMExceptionLog->FilterGraphics.Clear();
  if (cbInvalidGraphic->Checked == true)
    SMExceptionLog->FilterGraphics << efInvalidGraphic;
  if (cbInvalidGraphicOperation->Checked == true)
    SMExceptionLog->FilterGraphics << efInvalidGraphicOperation;

  if (rbDivideByZero->Checked == true) {
    i = 0;
    div_t x = div(23, i);
    ShowMessage(IntToStr(x.quot));
  }
  else
  if (rbConvertError->Checked == true) {
    i = StrToInt("aaa" + IntToStr(random(19)));
    Caption = FloatToStr(i);
  }
  else
  if (rbStringListError->Checked == true)
    ShowMessage(lbLog->Items->Strings[-3]);
/*  else
  if (rbAccessViolation->Checked == true)
    GetClass("TDBGrid")->Create();
  else
  if (rbInvalidPointer->Checked == true)
    raise EInvalidPointer->Create('InvalidPointer')
  else
  if (rbResNotFound->Checked == true)
    raise EResNotFound.Create('ResNotFound')
*/
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::SMExceptionLogSaveException(TObject *Sender,
      Exception *E, AnsiString &LogText, bool &Accept)
{
  lbLog->Items->Add(FormatDateTime("dd mmm yyyy, hh:nn:ss", Now()) + ": we must fix this bug in new build (see smevent.log file)");
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::AddSourceInfoClick(TObject *Sender)
{
  if (cbAddSeparator->Checked == true)
    SMExceptionLog->Formats << lfSourceLine;
  else
    SMExceptionLog->Formats >> lfSourceLine;
}
//---------------------------------------------------------------------------
